scala.concurrent.duration

# Duration

#### object Duration extends Serializable

Source
  Duration.scala

Linear Supertypes
Serializable, java.io.Serializable, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Duration
2. Serializable
3. Serializable
4. AnyRef
5. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### sealed abstract class Infinite extends Duration

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### implicit object DurationIsOrdered extends Ordering[Duration]

   The natural ordering of durations matches the natural ordering for Double, including non-finite values.

7. #### val Inf: Infinite

   Infinite duration: greater than any other (apart from Undefined) and not equal to any other but itself.

   Infinite duration: greater than any other (apart from Undefined) and not equal to any other but itself. This value closely corresponds to Double.PositiveInfinity, matching its semantics in arithmetic operations.

8. #### val MinusInf: Infinite

   Infinite duration: less than any other and not equal to any other but itself.

   Infinite duration: less than any other and not equal to any other but itself. This value closely corresponds to Double.NegativeInfinity, matching its semantics in arithmetic operations.

9. #### val Undefined: Infinite

   The Undefined value corresponds closely to Double.

   The Undefined value corresponds closely to Double.NaN:

   - it is the result of otherwise invalid operations
   - it does not equal itself (according to `equals()`)
   - it compares greater than any other Duration apart from itself (for which `compare` returns 0)

   The particular comparison semantics mirror those of Double.NaN.

   Use `eq` when checking an input of a method against this value.

10. #### val Zero: FiniteDuration

    Preconstructed value of `0.days`.

11. #### def apply(s: String): Duration

    Parse String into Duration.

    Parse String into Duration. Format is `"<length><unit>"`, where whitespace is allowed before, between and after the parts. Infinities are designated by `"Inf"`, `"PlusInf"`, `"+Inf"` and `"-Inf"` or `"MinusInf"`.

    Exceptions thrown
      NumberFormatException

      if format is not parseable

12. #### def apply(length: Long, unit: String): FiniteDuration

    Construct a finite duration from the given length and time unit, where the latter is looked up in a list of string representation.

    Construct a finite duration from the given length and time unit, where the latter is looked up in a list of string representation. Valid choices are:

    `d, day, h, hour, min, minute, s, sec, second, ms, milli, millisecond, µs, micro, microsecond, ns, nano, nanosecond` and their pluralized forms (for every but the first mentioned form of each unit, i.e. no "ds", but "days").

13. #### def apply(length: Long, unit: TimeUnit): FiniteDuration

    Construct a finite duration from the given length and time unit.

    Construct a finite duration from the given length and time unit. The unit given is retained throughout calculations as long as possible, so that it can be retrieved later.

14. #### def apply(length: Double, unit: TimeUnit): Duration

    Construct a Duration from the given length and unit.

    Construct a Duration from the given length and unit. Observe that nanosecond precision may be lost if

    - the unit is NANOSECONDS
    - and the length has an absolute value greater than 2^53

    Infinite inputs (and NaN) are converted into Duration.Inf, Duration.MinusInf and Duration.Undefined, respectively.

    Exceptions thrown
      IllegalArgumentException

      if the length was finite but the resulting duration cannot be expressed as a FiniteDuration

15. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

16. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ()
    Note

      not specified by SLS as a member of AnyRef

17. #### def create(s: String): Duration

    Parse String into Duration.

    Parse String into Duration. Format is `"<length><unit>"`, where whitespace is allowed before, between and after the parts. Infinities are designated by `"Inf"`, `"PlusInf"`, `"+Inf"` and `"-Inf"` or `"MinusInf"`.

    Exceptions thrown
      NumberFormatException

      if format is not parseable

18. #### def create(length: Long, unit: String): FiniteDuration

    Construct a finite duration from the given length and time unit, where the latter is looked up in a list of string representation.

    Construct a finite duration from the given length and time unit, where the latter is looked up in a list of string representation. Valid choices are:

    `d, day, h, hour, min, minute, s, sec, second, ms, milli, millisecond, µs, micro, microsecond, ns, nano, nanosecond` and their pluralized forms (for every but the first mentioned form of each unit, i.e. no "ds", but "days").

19. #### def create(length: Double, unit: TimeUnit): Duration

    Construct a Duration from the given length and unit.

    Construct a Duration from the given length and unit. Observe that nanosecond precision may be lost if

    - the unit is NANOSECONDS
    - and the length has an absolute value greater than 2^53

    Infinite inputs (and NaN) are converted into Duration.Inf, Duration.MinusInf and Duration.Undefined, respectively.

    Exceptions thrown
      IllegalArgumentException

      if the length was finite but the resulting duration cannot be expressed as a FiniteDuration

20. #### def create(length: Long, unit: TimeUnit): FiniteDuration

    Construct a finite duration from the given length and time unit.

    Construct a finite duration from the given length and time unit. The unit given is retained throughout calculations as long as possible, so that it can be retrieved later.

21. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws ()
    Note

      not specified by SLS as a member of AnyRef

24. #### def fromNanos(nanos: Long): FiniteDuration

    Construct a finite duration from the given number of nanoseconds.

    Construct a finite duration from the given number of nanoseconds. The result will have the coarsest possible time unit which can exactly express this duration.

    Exceptions thrown
      IllegalArgumentException

      for `Long.MinValue` since that would lead to inconsistent behavior afterwards (cannot be negated)

25. #### def fromNanos(nanos: Double): Duration

    Construct a possibly infinite or undefined Duration from the given number of nanoseconds.

    Construct a possibly infinite or undefined Duration from the given number of nanoseconds.

    - `Double.PositiveInfinity` is mapped to Duration.Inf
    - `Double.NegativeInfinity` is mapped to Duration.MinusInf
    - `Double.NaN` is mapped to Duration.Undefined
    - `-0d` is mapped to Duration.Zero (exactly like `0d`)

    The semantics of the resulting Duration objects matches the semantics of their Double counterparts with respect to arithmetic operations.

    Exceptions thrown
      IllegalArgumentException

      if the length was finite but the resulting duration cannot be expressed as a FiniteDuration

26. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

27. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

28. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

29. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

30. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

31. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

32. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

33. #### val timeUnit: Map[String, TimeUnit]

    Attributes
      protected[scala.concurrent.duration]

34. #### val timeUnitName: Map[TimeUnit, String]

    Attributes
      protected[scala.concurrent.duration]

35. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

36. #### def unapply(d: Duration): Option[(Long, TimeUnit)]

    Extract length and time unit out of a duration, if it is finite.

37. #### def unapply(s: String): Option[(Long, TimeUnit)]

    Extract length and time unit out of a string, where the format must match the description for apply(String).

    Extract length and time unit out of a string, where the format must match the description for apply(String). The extractor will not match for malformed strings or non-finite durations.

38. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

39. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

40. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws ()

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped